diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/InlineTypesTest.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/InlineTypesTest.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/InlineTypesTest.java
@@ -0,0 +1,505 @@
+/*
+ * Copyright (c) 2017, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package runtime.valhalla.inlinetypes;
+
+import java.io.File;
+import java.io.IOException;
+import java.io.PrintWriter;
+import java.lang.constant.ClassDesc;
+import java.lang.constant.MethodTypeDesc;
+import java.lang.invoke.*;
+import java.lang.ref.*;
+import java.nio.ByteBuffer;
+import java.time.chrono.ThaiBuddhistChronology;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.concurrent.*;
+
+import static jdk.test.lib.Asserts.*;
+
+import java.lang.classfile.Label;
+import java.lang.classfile.TypeKind;
+import jdk.internal.vm.annotation.ImplicitlyConstructible;
+import jdk.internal.vm.annotation.LooselyConsistentValue;
+import jdk.internal.vm.annotation.NullRestricted;
+import jdk.test.lib.Platform;
+
+import javax.tools.*;
+
+import test.java.lang.invoke.lib.InstructionHelper;
+import static test.java.lang.invoke.lib.InstructionHelper.classDesc;
+
+/**
+ * @test InlineTypesTest
+ * @summary Test data movement with inline types
+ * @modules java.base/jdk.internal.value
+ * @library /test/lib /test/jdk/java/lang/invoke/common
+ * @modules java.base/jdk.internal.vm.annotation
+ * @build test.java.lang.invoke.lib.InstructionHelper
+ * @enablePreview
+ * @compile InlineTypesTest.java
+ * @run main/othervm -Xmx128m -XX:+ExplicitGCInvokesConcurrent
+ *                   -Xbootclasspath/a:. -XX:+UnlockDiagnosticVMOptions
+ *                   runtime.valhalla.inlinetypes.InlineTypesTest
+ * @run main/othervm -Xmx128m -XX:+ExplicitGCInvokesConcurrent
+ *                   -Xbootclasspath/a:. -XX:+UnlockDiagnosticVMOptions
+ *                   -XX:ForceNonTearable=*
+ *                   runtime.valhalla.inlinetypes.InlineTypesTest
+ */
+
+ final class ContainerValue1 {
+    static TestValue1 staticInlineField;
+    @NullRestricted
+    TestValue1 nonStaticInlineField;
+    TestValue1[] valueArray;
+}
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class TestValue1 {
+
+    static TestValue1 staticValue = getInstance();
+
+    final int i;
+    final String name;
+
+    public TestValue1() {
+        int now =  (int)System.nanoTime();
+        i = now;
+        name = Integer.valueOf(now).toString();
+    }
+
+    public TestValue1(int i) {
+        this.i = i;
+        name = Integer.valueOf(i).toString();
+    }
+
+    public static TestValue1 getInstance() {
+        return new TestValue1();
+    }
+
+    public static TestValue1 getNonBufferedInstance() {
+        return (TestValue1) staticValue;
+    }
+
+    public boolean verify() {
+        if (name == null) return i == 0;
+        return Integer.valueOf(i).toString().compareTo(name) == 0;
+    }
+}
+
+final class ContainerValue2 {
+    static TestValue2 staticInlineField;
+    @NullRestricted
+    TestValue2 nonStaticInlineField;
+    TestValue2[] valueArray;
+}
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class TestValue2 {
+    static TestValue2 staticValue = getInstance();
+
+    final long l;
+    final double d;
+    final String s;
+
+    public TestValue2() {
+        long now = System.nanoTime();
+        l = now;
+        String stringNow = Long.valueOf(now).toString();
+        s = stringNow;
+        d = Double.parseDouble(stringNow);
+    }
+
+    public TestValue2(long l) {
+        this.l = l;
+        String txt = Long.valueOf(l).toString();
+        s = txt;
+        d = Double.parseDouble(txt);
+    }
+
+    public static TestValue2 getInstance() {
+        return new TestValue2();
+    }
+
+    public static TestValue2 getNonBufferedInstance() {
+        return (TestValue2) staticValue;
+    }
+
+    public boolean verify() {
+        if (s == null) {
+            return d == 0 && l == 0;
+        }
+        return Long.valueOf(l).toString().compareTo(s) == 0
+                && Double.parseDouble(s) == d;
+    }
+}
+
+final class ContainerValue3 {
+    static TestValue3 staticInlineField;
+    @NullRestricted
+    TestValue3 nonStaticInlineField;
+    TestValue3[] valueArray;
+}
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class TestValue3 {
+
+    static TestValue3 staticValue = getInstance();
+
+    final byte b;
+
+    public TestValue3() {
+        b = 123;
+    }
+
+    public TestValue3(byte b) {
+        this.b = b;
+    }
+
+    public static TestValue3 getInstance() {
+        return new TestValue3();
+    }
+
+    public static TestValue3 getNonBufferedInstance() {
+        return (TestValue3) staticValue;
+    }
+
+    public boolean verify() {
+        return b == 0 || b == 123;
+    }
+}
+
+final class ContainerValue4 {
+    static TestValue4 staticInlineField;
+    @NullRestricted
+    TestValue4 nonStaticInlineField;
+    TestValue4[] valueArray;
+}
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+value class TestValue4 {
+
+    static TestValue4 staticValue = getInstance();
+
+    final byte b1;
+    final byte b2;
+    final byte b3;
+    final byte b4;
+    final short s1;
+    final short s2;
+    final int i;
+    final long l;
+    final String val;
+
+    public TestValue4() {
+        this((int) System.nanoTime());
+    }
+
+    public TestValue4(int i) {
+        this.i = i;
+        val = Integer.valueOf(i).toString();
+        ByteBuffer bf = ByteBuffer.allocate(8);
+        bf.putInt(0, i);
+        bf.putInt(4, i);
+        l = bf.getLong(0);
+        s1 = bf.getShort(2);
+        s2 = bf.getShort(0);
+        b1 = bf.get(3);
+        b2 = bf.get(2);
+        b3 = bf.get(1);
+        b4 = bf.get(0);
+    }
+
+    public static TestValue4 getInstance() {
+        return new TestValue4();
+    }
+
+    public static TestValue4 getNonBufferedInstance() {
+        return (TestValue4) staticValue;
+    }
+
+    public boolean verify() {
+        if (val == null) {
+            return i == 0 && l == 0 && b1 == 0 && b2 == 0 && b3 == 0 && b4 == 0
+                    && s1 == 0 && s2 == 0;
+        }
+        ByteBuffer bf = ByteBuffer.allocate(8);
+        bf.putInt(0, i);
+        bf.putInt(4, i);
+        long nl =  bf.getLong(0);
+        bf.clear();
+        bf.putShort(0, s2);
+        bf.putShort(2, s1);
+        int from_s = bf.getInt(0);
+        bf.clear();
+        bf.put(0, b4);
+        bf.put(1, b3);
+        bf.put(2, b2);
+        bf.put(3, b1);
+        int from_b = bf.getInt(0);
+        return l == nl && Integer.valueOf(i).toString().compareTo(val) == 0
+                && from_s == i && from_b == i;
+    }
+}
+
+public class InlineTypesTest {
+
+    public static void main(String[] args) {
+        Class<?> inlineClass = runtime.valhalla.inlinetypes.TestValue1.class;
+        Class<?> testClasses[] = {
+                runtime.valhalla.inlinetypes.TestValue1.class,
+                runtime.valhalla.inlinetypes.TestValue2.class,
+                runtime.valhalla.inlinetypes.TestValue3.class,
+                runtime.valhalla.inlinetypes.TestValue4.class
+        };
+        Class<?> containerClasses[] = {
+                runtime.valhalla.inlinetypes.ContainerValue1.class,
+                runtime.valhalla.inlinetypes.ContainerValue2.class,
+                runtime.valhalla.inlinetypes.ContainerValue3.class,
+                runtime.valhalla.inlinetypes.ContainerValue4.class
+        };
+
+        for (int i = 0; i < testClasses.length; i++) {
+            try {
+                testExecutionStackToLocalVariable(testClasses[i]);
+                testExecutionStackToFields(testClasses[i], containerClasses[i]);
+                testExecutionStackToInlineArray(testClasses[i], containerClasses[i]);
+            } catch (Throwable t) {
+                t.printStackTrace();
+                throw new RuntimeException(t);
+            }
+        }
+    }
+
+    static MethodHandles.Lookup LOOKUP = MethodHandles.lookup();
+
+    static void testExecutionStackToLocalVariable(Class<?> inlineClass) throws Throwable {
+        String sig = "()L" + inlineClass.getName().replace('.', '/') + ";";
+        final MethodTypeDesc voidReturnClass = MethodTypeDesc.ofDescriptor(sig);
+        final ClassDesc systemClassDesc = classDesc(System.class);
+        final ClassDesc inlineClassDesc = classDesc(inlineClass);
+        MethodHandle fromExecStackToLocalVar = InstructionHelper.buildMethodHandle(
+                LOOKUP,
+                "execStackToLocalVar",
+                MethodType.methodType(boolean.class),
+                CODE -> {
+                    CODE.invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"));
+                    int n = -1;
+                    while (n < 1024) {
+                        n++;
+                        CODE
+                        .invokestatic(inlineClassDesc, "getInstance", voidReturnClass)
+                        .astore(n);
+                        n++;
+                        CODE
+                        .invokestatic(inlineClassDesc, "getNonBufferedInstance", voidReturnClass)
+                        .astore(n);
+                    }
+                    CODE.invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"));
+                    Label endLabel = CODE.newLabel();
+                    while (n > 0) {
+                        CODE
+                        .aload(n)
+                        .invokevirtual(inlineClassDesc, "verify", MethodTypeDesc.ofDescriptor("()Z"))
+                        .iconst_1()
+                        .if_icmpne(endLabel);
+                        n--;
+                    }
+                    CODE
+                    .iconst_1()
+                    .returnInstruction(TypeKind.BooleanType)
+                    .labelBinding(endLabel)
+                    .iconst_0()
+                    .returnInstruction(TypeKind.BooleanType);
+                });
+        boolean result = (boolean) fromExecStackToLocalVar.invokeExact();
+        System.out.println(result);
+        assertTrue(result, "Invariant");
+    }
+
+    static void testExecutionStackToFields(Class<?> inlineClass, Class<?> containerClass) throws Throwable {
+        final int ITERATIONS = Platform.isDebugBuild() ? 3 : 512;
+        String sig = "()L" + inlineClass.getName().replace('.', '/') + ";";
+        final MethodTypeDesc voidReturnClass = MethodTypeDesc.ofDescriptor(sig);
+        final ClassDesc systemClassDesc = classDesc(System.class);
+        final ClassDesc inlineClassDesc = classDesc(inlineClass);
+        final ClassDesc containerClassDesc = classDesc(containerClass);
+
+        MethodHandle fromExecStackToFields = InstructionHelper.buildMethodHandle(
+                LOOKUP,
+                "execStackToFields",
+                MethodType.methodType(boolean.class),
+                CODE -> {
+                    Label loop = CODE.newLabel();
+                    Label end = CODE.newLabel();
+                    Label failed = CODE.newLabel();
+                    CODE
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"), false)
+                    .new_(containerClassDesc)
+                    .dup()
+                    .invokespecial(containerClassDesc, "<init>", MethodTypeDesc.ofDescriptor("()V"))
+                    .astore(1)
+                    .iconst_m1()
+                    .istore(2)
+                    .labelBinding(loop)
+                    .iload(2)
+                    .ldc(ITERATIONS)
+                    .if_icmpeq(end)
+                    .aload(1)
+                    .invokestatic(inlineClassDesc, "getInstance", voidReturnClass)
+                    .putfield(containerClassDesc, "nonStaticInlineField", inlineClassDesc)
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"))
+                    .aload(1)
+                    .getfield(containerClassDesc, "nonStaticInlineField", inlineClassDesc)
+                    .invokevirtual(inlineClassDesc, "verify", MethodTypeDesc.ofDescriptor("()Z"))
+                    .iconst_1()
+                    .if_icmpne(failed)
+                    .aload(1)
+                    .invokestatic(inlineClassDesc, "getNonBufferedInstance", voidReturnClass)
+                    .putfield(containerClassDesc, "nonStaticInlineField", inlineClassDesc)
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"))
+                    .aload(1)
+                    .getfield(containerClassDesc, "nonStaticInlineField", inlineClassDesc)
+                    .invokevirtual(inlineClassDesc, "verify", MethodTypeDesc.ofDescriptor("()Z"))
+                    .iconst_1()
+                    .if_icmpne(failed)
+                    .invokestatic(inlineClassDesc, "getInstance", voidReturnClass)
+                    .putstatic(containerClassDesc, "staticInlineField", inlineClassDesc)
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"))
+                    .getstatic(containerClassDesc, "staticInlineField", inlineClassDesc)
+                    .checkcast(inlineClassDesc)
+                    .invokevirtual(inlineClassDesc, "verify", MethodTypeDesc.ofDescriptor("()Z"))
+                    .iconst_1()
+                    .if_icmpne(failed)
+                    .invokestatic(inlineClassDesc, "getNonBufferedInstance", voidReturnClass)
+                    .putstatic(containerClassDesc, "staticInlineField", inlineClassDesc)
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"))
+                    .getstatic(containerClassDesc, "staticInlineField", inlineClassDesc)
+                    .checkcast(inlineClassDesc)
+                    .invokevirtual(inlineClassDesc, "verify", MethodTypeDesc.ofDescriptor("()Z"))
+                    .iconst_1()
+                    .if_icmpne(failed)
+                    .iinc(2, 1)
+                    .goto_(loop)
+                    .labelBinding(end)
+                    .iconst_1()
+                    .returnInstruction(TypeKind.BooleanType)
+                    .labelBinding(failed)
+                    .iconst_0()
+                    .returnInstruction(TypeKind.BooleanType);
+                });
+        boolean result = (boolean) fromExecStackToFields.invokeExact();
+        System.out.println(result);
+        assertTrue(result, "Invariant");
+    }
+
+    static void testExecutionStackToInlineArray(Class<?> inlineClass, Class<?> containerClass) throws Throwable {
+        final int ITERATIONS = Platform.isDebugBuild() ? 3 : 100;
+        String sig = "()L" + inlineClass.getName().replace('.', '/') + ";";
+        final MethodTypeDesc voidReturnClass = MethodTypeDesc.ofDescriptor(sig);
+        final ClassDesc systemClassDesc = classDesc(System.class);
+        final ClassDesc inlineClassDesc = classDesc(inlineClass);
+        final ClassDesc containerClassDesc = classDesc(containerClass);
+
+        MethodHandle fromExecStackToInlineArray = InstructionHelper.buildMethodHandle(
+                LOOKUP,
+                "execStackToInlineArray",
+                MethodType.methodType(boolean.class),
+                CODE -> {
+                    Label loop1 = CODE.newLabel();
+                    Label loop2 = CODE.newLabel();
+                    Label end1 = CODE.newLabel();
+                    Label end2 = CODE.newLabel();
+                    Label failed = CODE.newLabel();
+                    CODE
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"))
+                    .new_(containerClassDesc)
+                    .dup()
+                    .invokespecial(containerClassDesc, "<init>", MethodTypeDesc.ofDescriptor("()V"))
+                    .astore(1)
+                    .ldc(ITERATIONS * 3)
+                    .anewarray(inlineClassDesc)
+                    .astore(2)
+                    .aload(2)
+                    .aload(1)
+                    .swap()
+                    .putfield(containerClassDesc, "valueArray", inlineClassDesc.arrayType())
+                    .iconst_0()
+                    .istore(3)
+                    .labelBinding(loop1)
+                    .iload(3)
+                    .ldc(ITERATIONS *3)
+                    .if_icmpge(end1)
+                    .aload(2)
+                    .iload(3)
+                    .invokestatic(inlineClassDesc, "getInstance", voidReturnClass)
+                    .aastore()
+                    .iinc(3, 1)
+                    .aload(2)
+                    .iload(3)
+                    .invokestatic(inlineClassDesc, "getNonBufferedInstance", voidReturnClass)
+                    .aastore()
+                    .iinc(3, 1)
+                    .aload(2)
+                    .iload(3)
+                    .new_(inlineClassDesc)
+                    .dup()
+                    .invokespecial(inlineClassDesc, "<init>", MethodTypeDesc.ofDescriptor("()V"))
+                    .aastore()
+                    .iinc(3, 1)
+                    .goto_(loop1)
+                    .labelBinding(end1)
+                    .invokestatic(systemClassDesc, "gc", MethodTypeDesc.ofDescriptor("()V"))
+                    .iconst_0()
+                    .istore(3)
+                    .labelBinding(loop2)
+                    .iload(3)
+                    .ldc(ITERATIONS * 3)
+                    .if_icmpge(end2)
+                    .aload(2)
+                    .iload(3)
+                    .aaload()
+                    .invokevirtual(inlineClassDesc, "verify", MethodTypeDesc.ofDescriptor("()Z"))
+                    .iconst_1()
+                    .if_icmpne(failed)
+                    .iinc(3, 1)
+                    .goto_(loop2)
+                    .labelBinding(end2)
+                    .iconst_1()
+                    .returnInstruction(TypeKind.BooleanType)
+                    .labelBinding(failed)
+                    .iconst_0()
+                    .returnInstruction(TypeKind.BooleanType);
+                });
+        boolean result = (boolean) fromExecStackToInlineArray.invokeExact();
+        System.out.println(result);
+        assertTrue(result, "Invariant");
+    }
+
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/InlineWithJni.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/InlineWithJni.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/InlineWithJni.java
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2018, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package runtime.valhalla.inlinetypes;
+
+/* @test
+ * @summary test JNI functions with inline types
+ * @enablePreview
+ * @run main/othervm/native runtime.valhalla.inlinetypes.InlineWithJni
+ */
+public value class InlineWithJni {
+
+    static {
+        System.loadLibrary("InlineWithJni");
+    }
+
+    public static void main(String[] args) {
+        testJniMonitorOps();
+    }
+
+    final int x;
+
+    public InlineWithJni(int x) {
+        this.x = x;
+    }
+
+    public native void doJniMonitorEnter();
+    public native void doJniMonitorExit();
+
+    public static void testJniMonitorOps() {
+        boolean sawImse = false;
+        try {
+            new InlineWithJni(0).doJniMonitorEnter();
+        } catch (Throwable t) {
+            sawImse = checkImse(t);
+        }
+        if (!sawImse) {
+            throw new RuntimeException("JNI MonitorEnter did not fail");
+        }
+        sawImse = false;
+        try {
+            new InlineWithJni(0).doJniMonitorExit();
+        } catch (Throwable t) {
+            sawImse = checkImse(t);
+        }
+        if (!sawImse) {
+            throw new RuntimeException("JNI MonitorExit did not fail");
+        }
+    }
+
+    static boolean checkImse(Throwable t) {
+        if (t instanceof IllegalMonitorStateException) {
+            return true;
+        }
+        throw new RuntimeException(t);
+    }
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/JumboInline.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/JumboInline.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/JumboInline.java
@@ -0,0 +1,96 @@
+/*
+ * Copyright (c) 2018, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package runtime.valhalla.inlinetypes;
+
+import jdk.internal.vm.annotation.LooselyConsistentValue;
+import jdk.internal.vm.annotation.ImplicitlyConstructible;
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+public value class JumboInline {
+    final long l0;
+    final long l1;
+    final long l2;
+    final long l3;
+    final long l4;
+    final long l5;
+    final long l6;
+    final long l7;
+    final long l8;
+    final long l9;
+    final long l10;
+    final long l11;
+    final long l12;
+    final long l13;
+    final long l14;
+    final long l15;
+    final long l16;
+    final long l17;
+    final long l18;
+    final long l19;
+
+    public JumboInline(long l0Val, long l1Val) {
+        l0 = l0Val;
+        l1 = l1Val;
+        l2 = l0Val+1;
+        l3 = l1Val+2;
+        l4 = l0Val+3;
+        l5 = l1Val+4;
+        l6 = l0Val+5;
+        l7 = l1Val+6;
+        l8 = l0Val+7;
+        l9 = l1Val+8;
+        l10 = l0Val+9;
+        l11 = l1Val+10;
+        l12 = l0Val+11;
+        l13 = l1Val+12;
+        l14 = l0Val+13;
+        l15 = l1Val+14;
+        l16 = l0Val+15;
+        l17 = l1Val+16;
+        l18 = l0Val+17;
+        l19 = l1Val+18;
+    }
+
+    public boolean verify() {
+        return (l2 == (l0 + 1)  &&  l3 == (l1 + 2) && l4 == (l0 + 3)
+            && l5 == (l1 + 4) && l6 == (l0 + 5) && l7 == (l1 + 6) && l8 == (l0 + 7)
+            && l9 == (l1 + 8) && l10 == (l0 + 9) && l11 == (l1 + 10)
+            && l12 == (l0 + 11) && l13 == (l1 + 12) && l14 == (l1 + 13)
+            && l15 == (l1 + 14) && l16 == (l0 + l15) && l17 == (l1 + 16)
+            && l18 == (l0 + 17) && l19 == (l1 + 18));
+    }
+
+    public boolean equals(Object o) {
+        if(o instanceof JumboInline) {
+            JumboInline j = (JumboInline)o;
+            return (l0 == j.l0 && l1 == j.l1 && l2 == j.l2 && l3 == j.l3
+                    && l4 == j.l4 && l5 == j.l5 && l6 == j.l6 && l7 == j.l7
+                    && l8 == j.l8 && l9 == j.l9 && l10 == j.l10 && l11 == j.l11
+                    && l12 == j.l12 && l13 == j.l13 && l14 == j.l14 && l15 == j.l15
+                    && l16 == j.l16 && l17 == j.l17 && l18 == j.l18 && l19 == j.l19);
+        } else {
+            return false;
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/Long8Inline.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/Long8Inline.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/Long8Inline.java
@@ -0,0 +1,82 @@
+/*
+ * Copyright (c) 2015, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package runtime.valhalla.inlinetypes;
+
+import jdk.internal.vm.annotation.ImplicitlyConstructible;
+import jdk.internal.vm.annotation.LooselyConsistentValue;
+import jdk.test.lib.Asserts;
+
+@ImplicitlyConstructible
+@LooselyConsistentValue
+public final value class Long8Inline {
+
+    final long longField1;
+    final long longField2;
+    final long longField3;
+    final long longField4;
+    final long longField5;
+    final long longField6;
+    final long longField7;
+    final long longField8;
+
+    public Long8Inline(long l1, long l2, long l3, long l4, long l5, long l6, long l7, long l8) {
+        longField1 = l1;
+        longField2 = l2;
+        longField3 = l3;
+        longField4 = l4;
+        longField5 = l5;
+        longField6 = l6;
+        longField7 = l7;
+        longField8 = l8;
+    }
+
+    public long getLongField1() { return longField1; }
+    public long getLongField2() { return longField2; }
+    public long getLongField3() { return longField3; }
+    public long getLongField4() { return longField4; }
+    public long getLongField5() { return longField5; }
+    public long getLongField6() { return longField6; }
+    public long getLongField7() { return longField7; }
+    public long getLongField8() { return longField8; }
+
+    static void check(Long8Inline value,
+            long long1,
+            long long2,
+            long long3,
+            long long4,
+            long long5,
+            long long6,
+            long long7,
+            long long8) {
+        Asserts.assertEquals(value.getLongField1(), long1, "Field 1 incorrect");
+        Asserts.assertEquals(value.getLongField2(), long2, "Field 2 incorrect");
+        Asserts.assertEquals(value.getLongField3(), long3, "Field 3 incorrect");
+        Asserts.assertEquals(value.getLongField4(), long4, "Field 4 incorrect");
+        Asserts.assertEquals(value.getLongField5(), long5, "Field 5 incorrect");
+        Asserts.assertEquals(value.getLongField6(), long6, "Field 6 incorrect");
+        Asserts.assertEquals(value.getLongField7(), long7, "Field 7 incorrect");
+        Asserts.assertEquals(value.getLongField8(), long8, "Field 8 incorrect");
+    }
+
+}
